#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "GLWindow.h"


//----------------------------------------------------------------------------------------------------------------------
/// @brief This is the MainWindow Class which is generated by the Ui file, if we wish to add anything to the main
/// Ui we add it here
//----------------------------------------------------------------------------------------------------------------------
class MainWindow : public QMainWindow
{
Q_OBJECT
protected :
		//----------------------------------------------------------------------------------------------------------------------
    /// @brief override the keyPressEvent inherited from QObject so we can handle key presses.
    /// @param [in] _event the event to process
		//----------------------------------------------------------------------------------------------------------------------
    void keyPressEvent(
                       QKeyEvent *_event
                      );


		void keyReleaseEvent(
													QKeyEvent *_event
												 );


		//----------------------------------------------------------------------------------------------------------------------
		/// @brief overided event called each time the window is re-sized
		/// the size event is passed to the GLWindow created in the
		/// ctor of this class
		/// @param *_event the even called
		//----------------------------------------------------------------------------------------------------------------------
    void resizeEvent (
                      QResizeEvent * _event
                     );
public:
		//----------------------------------------------------------------------------------------------------------------------
    /// @brief ctor basically we create a GLWindow and parent it to
		/// this window so our GLWindow is the main canvas
		//----------------------------------------------------------------------------------------------------------------------
    MainWindow(QWidget *parent = 0);
		//----------------------------------------------------------------------------------------------------------------------
    /// @brief dtor
		//----------------------------------------------------------------------------------------------------------------------
    ~MainWindow();

private slots :

private:
		//----------------------------------------------------------------------------------------------------------------------
    /// @brief our gl window created in GLWindow.h
		//----------------------------------------------------------------------------------------------------------------------
    GLWindow *m_gl;

};

#endif // MAINWINDOW_H
