#include "SpaceShip.h"
#include <ngl/ShaderManager.h>

SpaceShip::SpaceShip(
                     ngl::Vector _pos,
                     std::string _fname
                     )
 {
   m_pos=_pos;
   m_mesh = new ngl::Obj(_fname);
   m_mesh->createVBO(GL_STATIC_DRAW);
	 m_rotation=0;
 }

void SpaceShip::draw()
{
  ngl::ShaderManager *shader=ngl::ShaderManager::instance();
  (*shader)["Blinn"]->use();
  m_transform.getCurrentTransform().setPosition(m_pos);
	m_transform.setRotation(0,m_rotation,0);
  m_transform.loadGlobalAndCurrentMatrixToShader("Blinn","ModelMatrix");
  m_mesh->draw();
}

const static float s_xExtents=45;
const static float s_yExtents=30;

void SpaceShip::move(
										  float _x,
											float _y
										 )
{
	float currentX=m_pos.m_x;
	float currentY=m_pos.m_y;
	m_pos.m_x+=_x;
	m_pos.m_y+=_y;
	if(m_pos.m_x<=-s_xExtents || m_pos.m_x>=s_xExtents)
	{
		m_pos.m_x=currentX;
	}


	if(m_pos.m_y<=-s_yExtents || m_pos.m_y>=s_yExtents)
	{
		m_pos.m_y=currentY;
	}
}

void SpaceShip::rotate(
												float _rot
											 )
{
	m_rotation+=_rot;
}









